---
title: Get a rule's version history
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Security Monitoring
---

# Get a rule's version history{% #get-a-rules-version-history %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in beta and may be subject to changes.
| Datadog site      | API endpoint                                                                                 |
| ----------------- | -------------------------------------------------------------------------------------------- |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/v2/security_monitoring/rules/{rule_id}/version_history |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/v2/security_monitoring/rules/{rule_id}/version_history |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/v2/security_monitoring/rules/{rule_id}/version_history      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/v2/security_monitoring/rules/{rule_id}/version_history      |
| us2.ddog-gov.com  | GET https://api.us2.ddog-gov.com/api/v2/security_monitoring/rules/{rule_id}/version_history  |
| app.datadoghq.com | GET https://api.datadoghq.com/api/v2/security_monitoring/rules/{rule_id}/version_history     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/v2/security_monitoring/rules/{rule_id}/version_history |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/v2/security_monitoring/rules/{rule_id}/version_history |

### Overview

Get a rule's version history. This endpoint requires the `security_monitoring_rules_read` permission.

### Arguments

#### Path Parameters

| Name                      | Type   | Description         |
| ------------------------- | ------ | ------------------- |
| rule_id [*required*] | string | The ID of the rule. |

#### Query Strings

| Name         | Type    | Description                                              |
| ------------ | ------- | -------------------------------------------------------- |
| page[size]   | integer | Size for a given page. The maximum allowed value is 100. |
| page[number] | integer | Specific page number to return.                          |

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response for getting the rule version history.

| Parent field             | Field                           | Type          | Description                                                                                                                                                                                                                                                                                                                                                                                                      |
| ------------------------ | ------------------------------- | ------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                          | data                            | object        | Data for the rule version history.                                                                                                                                                                                                                                                                                                                                                                               |
| data                     | attributes                      | object        | Response object containing the version history of a rule.                                                                                                                                                                                                                                                                                                                                                        |
| attributes               | count                           | int32         | The number of rule versions.                                                                                                                                                                                                                                                                                                                                                                                     |
| attributes               | data                            | object        | The `RuleVersionHistory` `data`.                                                                                                                                                                                                                                                                                                                                                                                 |
| additionalProperties     | <any-key>                       | object        | A rule version with a list of updates.                                                                                                                                                                                                                                                                                                                                                                           |
| <any-key>                | changes                         | [object]      | A list of changes.                                                                                                                                                                                                                                                                                                                                                                                               |
| changes                  | change                          | string        | The new value of the field.                                                                                                                                                                                                                                                                                                                                                                                      |
| changes                  | field                           | string        | The field that was changed.                                                                                                                                                                                                                                                                                                                                                                                      |
| changes                  | type                            | enum          | The type of change. Allowed enum values: `create,update,delete`                                                                                                                                                                                                                                                                                                                                                  |
| <any-key>                | rule                            |  <oneOf> | Create a new rule.                                                                                                                                                                                                                                                                                                                                                                                               |
| rule                     | Option 1                        | object        | Rule.                                                                                                                                                                                                                                                                                                                                                                                                            |
| Option 1                 | calculatedFields                | [object]      | Calculated fields. Only allowed for scheduled rules - in other words, when schedulingOptions is also defined.                                                                                                                                                                                                                                                                                                    |
| calculatedFields         | expression [*required*]    | string        | Expression.                                                                                                                                                                                                                                                                                                                                                                                                      |
| calculatedFields         | name [*required*]          | string        | Field name.                                                                                                                                                                                                                                                                                                                                                                                                      |
| Option 1                 | cases                           | [object]      | Cases for generating signals.                                                                                                                                                                                                                                                                                                                                                                                    |
| cases                    | actions                         | [object]      | Action to perform for each rule case.                                                                                                                                                                                                                                                                                                                                                                            |
| actions                  | options                         | object        | Options for the rule action                                                                                                                                                                                                                                                                                                                                                                                      |
| options                  | duration                        | int64         | Duration of the action in seconds. 0 indicates no expiration.                                                                                                                                                                                                                                                                                                                                                    |
| options                  | flaggedIPType                   | enum          | Used with the case action of type 'flag_ip'. The value specified in this field is applied as a flag to the IP addresses. Allowed enum values: `SUSPICIOUS,FLAGGED`                                                                                                                                                                                                                                               |
| options                  | userBehaviorName                | string        | Used with the case action of type 'user_behavior'. The value specified in this field is applied as a risk tag to all users affected by the rule.                                                                                                                                                                                                                                                                 |
| actions                  | type                            | enum          | The action type. Allowed enum values: `block_ip,block_user,user_behavior,flag_ip`                                                                                                                                                                                                                                                                                                                                |
| cases                    | condition                       | string        | A rule case contains logical operations (`>`,`>=`, `&&`, `||`) to determine if a signal should be generated based on the event counts in the previously defined queries.                                                                                                                                                                                                                                         |
| cases                    | customStatus                    | enum          | Severity of the Security Signal. Allowed enum values: `info,low,medium,high,critical`                                                                                                                                                                                                                                                                                                                            |
| cases                    | name                            | string        | Name of the case.                                                                                                                                                                                                                                                                                                                                                                                                |
| cases                    | notifications                   | [string]      | Notification targets for each rule case.                                                                                                                                                                                                                                                                                                                                                                         |
| cases                    | status                          | enum          | Severity of the Security Signal. Allowed enum values: `info,low,medium,high,critical`                                                                                                                                                                                                                                                                                                                            |
| Option 1                 | complianceSignalOptions         | object        | How to generate compliance signals. Useful for cloud_configuration rules only.                                                                                                                                                                                                                                                                                                                                   |
| complianceSignalOptions  | defaultActivationStatus         | boolean       | The default activation status.                                                                                                                                                                                                                                                                                                                                                                                   |
| complianceSignalOptions  | defaultGroupByFields            | [string]      | The default group by fields.                                                                                                                                                                                                                                                                                                                                                                                     |
| complianceSignalOptions  | userActivationStatus            | boolean       | Whether signals will be sent.                                                                                                                                                                                                                                                                                                                                                                                    |
| complianceSignalOptions  | userGroupByFields               | [string]      | Fields to use to group findings by when sending signals.                                                                                                                                                                                                                                                                                                                                                         |
| Option 1                 | createdAt                       | int64         | When the rule was created, timestamp in milliseconds.                                                                                                                                                                                                                                                                                                                                                            |
| Option 1                 | creationAuthorId                | int64         | User ID of the user who created the rule.                                                                                                                                                                                                                                                                                                                                                                        |
| Option 1                 | customMessage                   | string        | Custom/Overridden message for generated signals (used in case of Default rule update).                                                                                                                                                                                                                                                                                                                           |
| Option 1                 | customName                      | string        | Custom/Overridden name of the rule (used in case of Default rule update).                                                                                                                                                                                                                                                                                                                                        |
| Option 1                 | defaultTags                     | [string]      | Default Tags for default rules (included in tags)                                                                                                                                                                                                                                                                                                                                                                |
| Option 1                 | deprecationDate                 | int64         | When the rule will be deprecated, timestamp in milliseconds.                                                                                                                                                                                                                                                                                                                                                     |
| Option 1                 | filters                         | [object]      | Additional queries to filter matched events before they are processed. This field is deprecated for log detection, signal correlation, and workload security rules.                                                                                                                                                                                                                                              |
| filters                  | action                          | enum          | The type of filtering action. Allowed enum values: `require,suppress`                                                                                                                                                                                                                                                                                                                                            |
| filters                  | query                           | string        | Query for selecting logs to apply the filtering action.                                                                                                                                                                                                                                                                                                                                                          |
| Option 1                 | groupSignalsBy                  | [string]      | Additional grouping to perform on top of the existing groups in the query section. Must be a subset of the existing groups.                                                                                                                                                                                                                                                                                      |
| Option 1                 | hasExtendedTitle                | boolean       | Whether the notifications include the triggering group-by values in their title.                                                                                                                                                                                                                                                                                                                                 |
| Option 1                 | id                              | string        | The ID of the rule.                                                                                                                                                                                                                                                                                                                                                                                              |
| Option 1                 | isDefault                       | boolean       | Whether the rule is included by default.                                                                                                                                                                                                                                                                                                                                                                         |
| Option 1                 | isDeleted                       | boolean       | Whether the rule has been deleted.                                                                                                                                                                                                                                                                                                                                                                               |
| Option 1                 | isEnabled                       | boolean       | Whether the rule is enabled.                                                                                                                                                                                                                                                                                                                                                                                     |
| Option 1                 | message                         | string        | Message for generated signals.                                                                                                                                                                                                                                                                                                                                                                                   |
| Option 1                 | name                            | string        | The name of the rule.                                                                                                                                                                                                                                                                                                                                                                                            |
| Option 1                 | options                         | object        | Options.                                                                                                                                                                                                                                                                                                                                                                                                         |
| options                  | anomalyDetectionOptions         | object        | Options on anomaly detection method.                                                                                                                                                                                                                                                                                                                                                                             |
| anomalyDetectionOptions  | bucketDuration                  | enum          | Duration in seconds of the time buckets used to aggregate events matched by the rule. Must be greater than or equal to 300. Allowed enum values: `300,600,900,1800,3600,10800`                                                                                                                                                                                                                                   |
| anomalyDetectionOptions  | detectionTolerance              | enum          | An optional parameter that sets how permissive anomaly detection is. Higher values require higher deviations before triggering a signal. Allowed enum values: `1,2,3,4,5`                                                                                                                                                                                                                                        |
| anomalyDetectionOptions  | instantaneousBaseline           | boolean       | When set to true, Datadog uses previous values that fall within the defined learning window to construct the baseline, enabling the system to establish an accurate baseline more rapidly rather than relying solely on gradual learning over time.                                                                                                                                                              |
| anomalyDetectionOptions  | learningDuration                | enum          | Learning duration in hours. Anomaly detection waits for at least this amount of historical data before it starts evaluating. Allowed enum values: `1,6,12,24,48,168,336`                                                                                                                                                                                                                                         |
| anomalyDetectionOptions  | learningPeriodBaseline          | int64         | An optional override baseline to apply while the rule is in the learning period. Must be greater than or equal to 0.                                                                                                                                                                                                                                                                                             |
| options                  | complianceRuleOptions           | object        | Options for cloud_configuration rules. Fields `resourceType` and `regoRule` are mandatory when managing custom `cloud_configuration` rules.                                                                                                                                                                                                                                                                      |
| complianceRuleOptions    | complexRule                     | boolean       | Whether the rule is a complex one. Must be set to true if `regoRule.resourceTypes` contains more than one item. Defaults to false.                                                                                                                                                                                                                                                                               |
| complianceRuleOptions    | regoRule                        | object        | Rule details.                                                                                                                                                                                                                                                                                                                                                                                                    |
| regoRule                 | policy [*required*]        | string        | The policy written in `rego`, see: [https://www.openpolicyagent.org/docs/latest/policy-language/](https://www.openpolicyagent.org/docs/latest/policy-language/)                                                                                                                                                                                                                                                  |
| regoRule                 | resourceTypes [*required*] | [string]      | List of resource types that will be evaluated upon. Must have at least one element.                                                                                                                                                                                                                                                                                                                              |
| complianceRuleOptions    | resourceType                    | string        | Main resource type to be checked by the rule. It should be specified again in `regoRule.resourceTypes`.                                                                                                                                                                                                                                                                                                          |
| options                  | decreaseCriticalityBasedOnEnv   | boolean       | If true, signals in non-production environments have a lower severity than what is defined by the rule case, which can reduce signal noise. The severity is decreased by one level: `CRITICAL` in production becomes `HIGH` in non-production, `HIGH` becomes `MEDIUM` and so on. `INFO` remains `INFO`. The decrement is applied when the environment tag of the signal starts with `staging`, `test` or `dev`. |
| options                  | detectionMethod                 | enum          | The detection method. Allowed enum values: `threshold,new_value,anomaly_detection,impossible_travel,hardcoded,third_party,anomaly_threshold,sequence_detection`                                                                                                                                                                                                                                                  |
| options                  | evaluationWindow                | enum          | A time window is specified to match when at least one of the cases matches true. This is a sliding window and evaluates in real time. For third party detection method, this field is not used. Allowed enum values: `0,60,300,600,900,1800,3600,7200,10800,21600`                                                                                                                                               |
| options                  | hardcodedEvaluatorType          | enum          | Hardcoded evaluator type. Allowed enum values: `log4shell`                                                                                                                                                                                                                                                                                                                                                       |
| options                  | impossibleTravelOptions         | object        | Options on impossible travel detection method.                                                                                                                                                                                                                                                                                                                                                                   |
| impossibleTravelOptions  | baselineUserLocations           | boolean       | If true, signals are suppressed for the first 24 hours. In that time, Datadog learns the user's regular access locations. This can be helpful to reduce noise and infer VPN usage or credentialed API access.                                                                                                                                                                                                    |
| impossibleTravelOptions  | baselineUserLocationsDuration   | int32         | The duration in days during which Datadog learns the user's regular access locations. After this period, signals are generated for accesses from unknown locations.                                                                                                                                                                                                                                              |
| options                  | keepAlive                       | enum          | Once a signal is generated, the signal will remain "open" if a case is matched at least once within this keep alive window. For third party detection method, this field is not used. Allowed enum values: `0,60,300,600,900,1800,3600,7200,10800,21600`                                                                                                                                                         |
| options                  | maxSignalDuration               | enum          | A signal will "close" regardless of the query being matched once the time exceeds the maximum duration. This time is calculated from the first seen timestamp. Allowed enum values: `0,60,300,600,900,1800,3600,7200,10800,21600`                                                                                                                                                                                |
| options                  | newValueOptions                 | object        | Options on new value detection method.                                                                                                                                                                                                                                                                                                                                                                           |
| newValueOptions          | forgetAfter                     | int32         | The duration in days after which a learned value is forgotten.                                                                                                                                                                                                                                                                                                                                                   |
| newValueOptions          | instantaneousBaseline           | boolean       | When set to true, Datadog uses previous values that fall within the defined learning window to construct the baseline, enabling the system to establish an accurate baseline more rapidly rather than relying solely on gradual learning over time.                                                                                                                                                              |
| newValueOptions          | learningDuration                | int32         | The duration in days during which values are learned, and after which signals will be generated for values that weren't learned. If set to 0, a signal will be generated for all new values after the first value is learned.                                                                                                                                                                                    |
| newValueOptions          | learningMethod                  | enum          | The learning method used to determine when signals should be generated for values that weren't learned. Allowed enum values: `duration,threshold`                                                                                                                                                                                                                                                                |
| newValueOptions          | learningThreshold               | enum          | A number of occurrences after which signals will be generated for values that weren't learned. Allowed enum values: `0,1`                                                                                                                                                                                                                                                                                        |
| options                  | sequenceDetectionOptions        | object        | Options on sequence detection method.                                                                                                                                                                                                                                                                                                                                                                            |
| sequenceDetectionOptions | stepTransitions                 | [object]      | Transitions defining the allowed order of steps and their evaluation windows.                                                                                                                                                                                                                                                                                                                                    |
| stepTransitions          | child                           | string        | Name of the child step.                                                                                                                                                                                                                                                                                                                                                                                          |
| stepTransitions          | evaluationWindow                | enum          | A time window is specified to match when at least one of the cases matches true. This is a sliding window and evaluates in real time. For third party detection method, this field is not used. Allowed enum values: `0,60,300,600,900,1800,3600,7200,10800,21600`                                                                                                                                               |
| stepTransitions          | parent                          | string        | Name of the parent step.                                                                                                                                                                                                                                                                                                                                                                                         |
| sequenceDetectionOptions | steps                           | [object]      | Steps that define the conditions to be matched in sequence.                                                                                                                                                                                                                                                                                                                                                      |
| steps                    | condition                       | string        | Condition referencing rule queries (e.g., `a > 0`).                                                                                                                                                                                                                                                                                                                                                              |
| steps                    | evaluationWindow                | enum          | A time window is specified to match when at least one of the cases matches true. This is a sliding window and evaluates in real time. For third party detection method, this field is not used. Allowed enum values: `0,60,300,600,900,1800,3600,7200,10800,21600`                                                                                                                                               |
| steps                    | name                            | string        | Unique name identifying the step.                                                                                                                                                                                                                                                                                                                                                                                |
| options                  | thirdPartyRuleOptions           | object        | Options on third party detection method.                                                                                                                                                                                                                                                                                                                                                                         |
| thirdPartyRuleOptions    | defaultNotifications            | [string]      | Notification targets for the logs that do not correspond to any of the cases.                                                                                                                                                                                                                                                                                                                                    |
| thirdPartyRuleOptions    | defaultStatus                   | enum          | Severity of the Security Signal. Allowed enum values: `info,low,medium,high,critical`                                                                                                                                                                                                                                                                                                                            |
| thirdPartyRuleOptions    | rootQueries                     | [object]      | Queries to be combined with third party case queries. Each of them can have different group by fields, to aggregate differently based on the type of alert.                                                                                                                                                                                                                                                      |
| rootQueries              | groupByFields                   | [string]      | Fields to group by.                                                                                                                                                                                                                                                                                                                                                                                              |
| rootQueries              | query                           | string        | Query to run on logs.                                                                                                                                                                                                                                                                                                                                                                                            |
| thirdPartyRuleOptions    | signalTitleTemplate             | string        | A template for the signal title; if omitted, the title is generated based on the case name.                                                                                                                                                                                                                                                                                                                      |
| Option 1                 | queries                         | [object]      | Queries for selecting logs which are part of the rule.                                                                                                                                                                                                                                                                                                                                                           |
| queries                  | aggregation                     | enum          | The aggregation type. Allowed enum values: `count,cardinality,sum,max,new_value,geo_data,event_count,none`                                                                                                                                                                                                                                                                                                       |
| queries                  | customQueryExtension            | string        | Query extension to append to the logs query.                                                                                                                                                                                                                                                                                                                                                                     |
| queries                  | dataSource                      | enum          | Source of events, either logs, audit trail, security signals, or Datadog events. `app_sec_spans` is deprecated in favor of `spans`. Allowed enum values: `logs,audit,app_sec_spans,spans,security_runtime,network,events,security_signals`                                                                                                                                                                       |
| queries                  | distinctFields                  | [string]      | Field for which the cardinality is measured. Sent as an array.                                                                                                                                                                                                                                                                                                                                                   |
| queries                  | groupByFields                   | [string]      | Fields to group by.                                                                                                                                                                                                                                                                                                                                                                                              |
| queries                  | hasOptionalGroupByFields        | boolean       | When false, events without a group-by value are ignored by the rule. When true, events with missing group-by fields are processed with `N/A`, replacing the missing values.                                                                                                                                                                                                                                      |
| queries                  | index                           | string        | **This field is currently unstable and might be removed in a minor version upgrade.** The index to run the query on, if the `dataSource` is `logs`. Only used for scheduled rules - in other words, when the `schedulingOptions` field is present in the rule payload.                                                                                                                                           |
| queries                  | indexes                         | [string]      | List of indexes to query when the `dataSource` is `logs`. Only used for scheduled rules, such as when the `schedulingOptions` field is present in the rule payload.                                                                                                                                                                                                                                              |
| queries                  | metric                          | string        | **DEPRECATED**: (Deprecated) The target field to aggregate over when using the sum or max aggregations. `metrics` field should be used instead.                                                                                                                                                                                                                                                                  |
| queries                  | metrics                         | [string]      | Group of target fields to aggregate over when using the sum, max, geo data, or new value aggregations. The sum, max, and geo data aggregations only accept one value in this list, whereas the new value aggregation accepts up to five values.                                                                                                                                                                  |
| queries                  | name                            | string        | Name of the query.                                                                                                                                                                                                                                                                                                                                                                                               |
| queries                  | query                           | string        | Query to run on logs.                                                                                                                                                                                                                                                                                                                                                                                            |
| Option 1                 | referenceTables                 | [object]      | Reference tables for the rule.                                                                                                                                                                                                                                                                                                                                                                                   |
| referenceTables          | checkPresence                   | boolean       | Whether to include or exclude the matched values.                                                                                                                                                                                                                                                                                                                                                                |
| referenceTables          | columnName                      | string        | The name of the column in the reference table.                                                                                                                                                                                                                                                                                                                                                                   |
| referenceTables          | logFieldPath                    | string        | The field in the log to match against the reference table.                                                                                                                                                                                                                                                                                                                                                       |
| referenceTables          | ruleQueryName                   | string        | The name of the query to apply the reference table to.                                                                                                                                                                                                                                                                                                                                                           |
| referenceTables          | tableName                       | string        | The name of the reference table.                                                                                                                                                                                                                                                                                                                                                                                 |
| Option 1                 | schedulingOptions               | object        | Options for scheduled rules. When this field is present, the rule runs based on the schedule. When absent, it runs real-time on ingested logs.                                                                                                                                                                                                                                                                   |
| schedulingOptions        | rrule                           | string        | Schedule for the rule queries, written in RRULE syntax. See [RFC](https://icalendar.org/iCalendar-RFC-5545/3-8-5-3-recurrence-rule.html) for syntax reference.                                                                                                                                                                                                                                                   |
| schedulingOptions        | start                           | string        | Start date for the schedule, in ISO 8601 format without timezone.                                                                                                                                                                                                                                                                                                                                                |
| schedulingOptions        | timezone                        | string        | Time zone of the start date, in the [tz database](https://en.wikipedia.org/wiki/List_of_tz_database_time_zones) format.                                                                                                                                                                                                                                                                                          |
| Option 1                 | tags                            | [string]      | Tags for generated signals.                                                                                                                                                                                                                                                                                                                                                                                      |
| Option 1                 | thirdPartyCases                 | [object]      | Cases for generating signals from third-party rules. Only available for third-party rules.                                                                                                                                                                                                                                                                                                                       |
| thirdPartyCases          | customStatus                    | enum          | Severity of the Security Signal. Allowed enum values: `info,low,medium,high,critical`                                                                                                                                                                                                                                                                                                                            |
| thirdPartyCases          | name                            | string        | Name of the case.                                                                                                                                                                                                                                                                                                                                                                                                |
| thirdPartyCases          | notifications                   | [string]      | Notification targets for each rule case.                                                                                                                                                                                                                                                                                                                                                                         |
| thirdPartyCases          | query                           | string        | A query to map a third party event to this case.                                                                                                                                                                                                                                                                                                                                                                 |
| thirdPartyCases          | status                          | enum          | Severity of the Security Signal. Allowed enum values: `info,low,medium,high,critical`                                                                                                                                                                                                                                                                                                                            |
| Option 1                 | type                            | enum          | The rule type. Allowed enum values: `log_detection,infrastructure_configuration,workload_security,cloud_configuration,application_security,api_security,workload_activity`                                                                                                                                                                                                                                       |
| Option 1                 | updateAuthorId                  | int64         | User ID of the user who updated the rule.                                                                                                                                                                                                                                                                                                                                                                        |
| Option 1                 | updatedAt                       | int64         | The date the rule was last updated, in milliseconds.                                                                                                                                                                                                                                                                                                                                                             |
| Option 1                 | version                         | int64         | The version of the rule.                                                                                                                                                                                                                                                                                                                                                                                         |
| rule                     | Option 2                        | object        | Rule.                                                                                                                                                                                                                                                                                                                                                                                                            |
| Option 2                 | cases                           | [object]      | Cases for generating signals.                                                                                                                                                                                                                                                                                                                                                                                    |
| cases                    | actions                         | [object]      | Action to perform for each rule case.                                                                                                                                                                                                                                                                                                                                                                            |
| actions                  | options                         | object        | Options for the rule action                                                                                                                                                                                                                                                                                                                                                                                      |
| options                  | duration                        | int64         | Duration of the action in seconds. 0 indicates no expiration.                                                                                                                                                                                                                                                                                                                                                    |
| options                  | flaggedIPType                   | enum          | Used with the case action of type 'flag_ip'. The value specified in this field is applied as a flag to the IP addresses. Allowed enum values: `SUSPICIOUS,FLAGGED`                                                                                                                                                                                                                                               |
| options                  | userBehaviorName                | string        | Used with the case action of type 'user_behavior'. The value specified in this field is applied as a risk tag to all users affected by the rule.                                                                                                                                                                                                                                                                 |
| actions                  | type                            | enum          | The action type. Allowed enum values: `block_ip,block_user,user_behavior,flag_ip`                                                                                                                                                                                                                                                                                                                                |
| cases                    | condition                       | string        | A rule case contains logical operations (`>`,`>=`, `&&`, `||`) to determine if a signal should be generated based on the event counts in the previously defined queries.                                                                                                                                                                                                                                         |
| cases                    | customStatus                    | enum          | Severity of the Security Signal. Allowed enum values: `info,low,medium,high,critical`                                                                                                                                                                                                                                                                                                                            |
| cases                    | name                            | string        | Name of the case.                                                                                                                                                                                                                                                                                                                                                                                                |
| cases                    | notifications                   | [string]      | Notification targets for each rule case.                                                                                                                                                                                                                                                                                                                                                                         |
| cases                    | status                          | enum          | Severity of the Security Signal. Allowed enum values: `info,low,medium,high,critical`                                                                                                                                                                                                                                                                                                                            |
| Option 2                 | createdAt                       | int64         | When the rule was created, timestamp in milliseconds.                                                                                                                                                                                                                                                                                                                                                            |
| Option 2                 | creationAuthorId                | int64         | User ID of the user who created the rule.                                                                                                                                                                                                                                                                                                                                                                        |
| Option 2                 | customMessage                   | string        | Custom/Overridden message for generated signals (used in case of Default rule update).                                                                                                                                                                                                                                                                                                                           |
| Option 2                 | customName                      | string        | Custom/Overridden name of the rule (used in case of Default rule update).                                                                                                                                                                                                                                                                                                                                        |
| Option 2                 | deprecationDate                 | int64         | When the rule will be deprecated, timestamp in milliseconds.                                                                                                                                                                                                                                                                                                                                                     |
| Option 2                 | filters                         | [object]      | Additional queries to filter matched events before they are processed. This field is deprecated for log detection, signal correlation, and workload security rules.                                                                                                                                                                                                                                              |
| filters                  | action                          | enum          | The type of filtering action. Allowed enum values: `require,suppress`                                                                                                                                                                                                                                                                                                                                            |
| filters                  | query                           | string        | Query for selecting logs to apply the filtering action.                                                                                                                                                                                                                                                                                                                                                          |
| Option 2                 | hasExtendedTitle                | boolean       | Whether the notifications include the triggering group-by values in their title.                                                                                                                                                                                                                                                                                                                                 |
| Option 2                 | id                              | string        | The ID of the rule.                                                                                                                                                                                                                                                                                                                                                                                              |
| Option 2                 | isDefault                       | boolean       | Whether the rule is included by default.                                                                                                                                                                                                                                                                                                                                                                         |
| Option 2                 | isDeleted                       | boolean       | Whether the rule has been deleted.                                                                                                                                                                                                                                                                                                                                                                               |
| Option 2                 | isEnabled                       | boolean       | Whether the rule is enabled.                                                                                                                                                                                                                                                                                                                                                                                     |
| Option 2                 | message                         | string        | Message for generated signals.                                                                                                                                                                                                                                                                                                                                                                                   |
| Option 2                 | name                            | string        | The name of the rule.                                                                                                                                                                                                                                                                                                                                                                                            |
| Option 2                 | options                         | object        | Options.                                                                                                                                                                                                                                                                                                                                                                                                         |
| options                  | anomalyDetectionOptions         | object        | Options on anomaly detection method.                                                                                                                                                                                                                                                                                                                                                                             |
| anomalyDetectionOptions  | bucketDuration                  | enum          | Duration in seconds of the time buckets used to aggregate events matched by the rule. Must be greater than or equal to 300. Allowed enum values: `300,600,900,1800,3600,10800`                                                                                                                                                                                                                                   |
| anomalyDetectionOptions  | detectionTolerance              | enum          | An optional parameter that sets how permissive anomaly detection is. Higher values require higher deviations before triggering a signal. Allowed enum values: `1,2,3,4,5`                                                                                                                                                                                                                                        |
| anomalyDetectionOptions  | instantaneousBaseline           | boolean       | When set to true, Datadog uses previous values that fall within the defined learning window to construct the baseline, enabling the system to establish an accurate baseline more rapidly rather than relying solely on gradual learning over time.                                                                                                                                                              |
| anomalyDetectionOptions  | learningDuration                | enum          | Learning duration in hours. Anomaly detection waits for at least this amount of historical data before it starts evaluating. Allowed enum values: `1,6,12,24,48,168,336`                                                                                                                                                                                                                                         |
| anomalyDetectionOptions  | learningPeriodBaseline          | int64         | An optional override baseline to apply while the rule is in the learning period. Must be greater than or equal to 0.                                                                                                                                                                                                                                                                                             |
| options                  | complianceRuleOptions           | object        | Options for cloud_configuration rules. Fields `resourceType` and `regoRule` are mandatory when managing custom `cloud_configuration` rules.                                                                                                                                                                                                                                                                      |
| complianceRuleOptions    | complexRule                     | boolean       | Whether the rule is a complex one. Must be set to true if `regoRule.resourceTypes` contains more than one item. Defaults to false.                                                                                                                                                                                                                                                                               |
| complianceRuleOptions    | regoRule                        | object        | Rule details.                                                                                                                                                                                                                                                                                                                                                                                                    |
| regoRule                 | policy [*required*]        | string        | The policy written in `rego`, see: [https://www.openpolicyagent.org/docs/latest/policy-language/](https://www.openpolicyagent.org/docs/latest/policy-language/)                                                                                                                                                                                                                                                  |
| regoRule                 | resourceTypes [*required*] | [string]      | List of resource types that will be evaluated upon. Must have at least one element.                                                                                                                                                                                                                                                                                                                              |
| complianceRuleOptions    | resourceType                    | string        | Main resource type to be checked by the rule. It should be specified again in `regoRule.resourceTypes`.                                                                                                                                                                                                                                                                                                          |
| options                  | decreaseCriticalityBasedOnEnv   | boolean       | If true, signals in non-production environments have a lower severity than what is defined by the rule case, which can reduce signal noise. The severity is decreased by one level: `CRITICAL` in production becomes `HIGH` in non-production, `HIGH` becomes `MEDIUM` and so on. `INFO` remains `INFO`. The decrement is applied when the environment tag of the signal starts with `staging`, `test` or `dev`. |
| options                  | detectionMethod                 | enum          | The detection method. Allowed enum values: `threshold,new_value,anomaly_detection,impossible_travel,hardcoded,third_party,anomaly_threshold,sequence_detection`                                                                                                                                                                                                                                                  |
| options                  | evaluationWindow                | enum          | A time window is specified to match when at least one of the cases matches true. This is a sliding window and evaluates in real time. For third party detection method, this field is not used. Allowed enum values: `0,60,300,600,900,1800,3600,7200,10800,21600`                                                                                                                                               |
| options                  | hardcodedEvaluatorType          | enum          | Hardcoded evaluator type. Allowed enum values: `log4shell`                                                                                                                                                                                                                                                                                                                                                       |
| options                  | impossibleTravelOptions         | object        | Options on impossible travel detection method.                                                                                                                                                                                                                                                                                                                                                                   |
| impossibleTravelOptions  | baselineUserLocations           | boolean       | If true, signals are suppressed for the first 24 hours. In that time, Datadog learns the user's regular access locations. This can be helpful to reduce noise and infer VPN usage or credentialed API access.                                                                                                                                                                                                    |
| impossibleTravelOptions  | baselineUserLocationsDuration   | int32         | The duration in days during which Datadog learns the user's regular access locations. After this period, signals are generated for accesses from unknown locations.                                                                                                                                                                                                                                              |
| options                  | keepAlive                       | enum          | Once a signal is generated, the signal will remain "open" if a case is matched at least once within this keep alive window. For third party detection method, this field is not used. Allowed enum values: `0,60,300,600,900,1800,3600,7200,10800,21600`                                                                                                                                                         |
| options                  | maxSignalDuration               | enum          | A signal will "close" regardless of the query being matched once the time exceeds the maximum duration. This time is calculated from the first seen timestamp. Allowed enum values: `0,60,300,600,900,1800,3600,7200,10800,21600`                                                                                                                                                                                |
| options                  | newValueOptions                 | object        | Options on new value detection method.                                                                                                                                                                                                                                                                                                                                                                           |
| newValueOptions          | forgetAfter                     | int32         | The duration in days after which a learned value is forgotten.                                                                                                                                                                                                                                                                                                                                                   |
| newValueOptions          | instantaneousBaseline           | boolean       | When set to true, Datadog uses previous values that fall within the defined learning window to construct the baseline, enabling the system to establish an accurate baseline more rapidly rather than relying solely on gradual learning over time.                                                                                                                                                              |
| newValueOptions          | learningDuration                | int32         | The duration in days during which values are learned, and after which signals will be generated for values that weren't learned. If set to 0, a signal will be generated for all new values after the first value is learned.                                                                                                                                                                                    |
| newValueOptions          | learningMethod                  | enum          | The learning method used to determine when signals should be generated for values that weren't learned. Allowed enum values: `duration,threshold`                                                                                                                                                                                                                                                                |
| newValueOptions          | learningThreshold               | enum          | A number of occurrences after which signals will be generated for values that weren't learned. Allowed enum values: `0,1`                                                                                                                                                                                                                                                                                        |
| options                  | sequenceDetectionOptions        | object        | Options on sequence detection method.                                                                                                                                                                                                                                                                                                                                                                            |
| sequenceDetectionOptions | stepTransitions                 | [object]      | Transitions defining the allowed order of steps and their evaluation windows.                                                                                                                                                                                                                                                                                                                                    |
| stepTransitions          | child                           | string        | Name of the child step.                                                                                                                                                                                                                                                                                                                                                                                          |
| stepTransitions          | evaluationWindow                | enum          | A time window is specified to match when at least one of the cases matches true. This is a sliding window and evaluates in real time. For third party detection method, this field is not used. Allowed enum values: `0,60,300,600,900,1800,3600,7200,10800,21600`                                                                                                                                               |
| stepTransitions          | parent                          | string        | Name of the parent step.                                                                                                                                                                                                                                                                                                                                                                                         |
| sequenceDetectionOptions | steps                           | [object]      | Steps that define the conditions to be matched in sequence.                                                                                                                                                                                                                                                                                                                                                      |
| steps                    | condition                       | string        | Condition referencing rule queries (e.g., `a > 0`).                                                                                                                                                                                                                                                                                                                                                              |
| steps                    | evaluationWindow                | enum          | A time window is specified to match when at least one of the cases matches true. This is a sliding window and evaluates in real time. For third party detection method, this field is not used. Allowed enum values: `0,60,300,600,900,1800,3600,7200,10800,21600`                                                                                                                                               |
| steps                    | name                            | string        | Unique name identifying the step.                                                                                                                                                                                                                                                                                                                                                                                |
| options                  | thirdPartyRuleOptions           | object        | Options on third party detection method.                                                                                                                                                                                                                                                                                                                                                                         |
| thirdPartyRuleOptions    | defaultNotifications            | [string]      | Notification targets for the logs that do not correspond to any of the cases.                                                                                                                                                                                                                                                                                                                                    |
| thirdPartyRuleOptions    | defaultStatus                   | enum          | Severity of the Security Signal. Allowed enum values: `info,low,medium,high,critical`                                                                                                                                                                                                                                                                                                                            |
| thirdPartyRuleOptions    | rootQueries                     | [object]      | Queries to be combined with third party case queries. Each of them can have different group by fields, to aggregate differently based on the type of alert.                                                                                                                                                                                                                                                      |
| rootQueries              | groupByFields                   | [string]      | Fields to group by.                                                                                                                                                                                                                                                                                                                                                                                              |
| rootQueries              | query                           | string        | Query to run on logs.                                                                                                                                                                                                                                                                                                                                                                                            |
| thirdPartyRuleOptions    | signalTitleTemplate             | string        | A template for the signal title; if omitted, the title is generated based on the case name.                                                                                                                                                                                                                                                                                                                      |
| Option 2                 | queries                         | [object]      | Queries for selecting logs which are part of the rule.                                                                                                                                                                                                                                                                                                                                                           |
| queries                  | aggregation                     | enum          | The aggregation type. Allowed enum values: `count,cardinality,sum,max,new_value,geo_data,event_count,none`                                                                                                                                                                                                                                                                                                       |
[...]
